###########################################
######## Nombres pseudo-alatoires ########

5 %% 3
y1=324903 %% 531 
u1=y1/531 
y2=(324903*y1) %% 531 
u2=y2/531
y3=(324903*y2) %% 531 
u3=y3/531
n=20
x=1
u=1
for (k in c(1:n))
  {x[k+1]=(x[k]*20)%% 17
  u[k]=x[k+1]/7}
x[2:(n+1)]
u

n=10; x=1000; u=1
m=2^31-1; a=16807
for (k in c(1:n))
{x[k+1]=(x[k]*a)%% m
u[k]=x[k+1]/m}
x[2:(n+1)]
u
runif(100000,0,1)
rbinom(200,5,0.5)
rexp(10,0.1)

runif(n,0,1)

########################################
######## Methode de Monte-Carlo ########

rbinom(1,8,0.4)
rbinom(1000,1,0.5)
rnorm(1,0,1)
rnorm(10,-2,5)
rexp(4,3)
runif(5,-4,-1)
max(rpois(100000,5))

pbinom(1.7,4,0.6)
pbinom(1.2,4,0.6)
pbinom(5,4,0.6)
pnorm(4,0,1)
pnorm(-30,-2,10)

dbinom(3,4,0.6)
dbinom(10,4,0.6)
dnorm(0,0,1)
1/sqrt(2*pi)

qbinom(0.95,4,0.6)
qbinom(0.5,4,0.6)
qnorm(0.5,0,1)
qnorm(0.975,0,1)
qnorm(0.95,0,1)
qnorm(0.7,-2,4)

n=400
X=rnorm(n,3,5)
hist(X)
(XX=mean(X))

n=10000
X=0
for (j in c(1:n))
  X[j]=rbinom(1,1,1/j)
plot(X)

n=200
X=0
for (j in c(1:n))
  X[j]=rnorm(1,10/sqrt(j),1)
plot(X)
hist(X[1:(n/4)])
mean(X[1:(n/4)])
hist(X[(n/2):n])
mean(X[(n/1.25):n])

n=100
p=0.6
X=rbinom(n,1,p)
XX=mean(X)
XX
n=1000
X=c()
for (j in c(1:n))
{X=c(X,rbinom(1,1,p))
  XX[j]=mean(X)
}
plot(c(1:n),XX,'l')
lines(c(1:n),rep(p,n),col="red")

n=50000
X=c()
XX=0
for (j in c(1:n))
{X=c(X,rbinom(1,1,p))
XX[j]=sqrt(j)*(mean(X)-p)/sqrt(p*(1-p))
}
plot(c(1:n),XX,'l')

m=1000
XX=0
for (j in c(1:m))
  {X=rbinom(n,1,p)
  XX[j]=sqrt(n)*(mean(X)-p)/sqrt(p*(1-p))
}
hist(XX)

m=1000
XX=0
for (j in c(1:m))
{X=rbinom(n,1,p)
XX[j]=sqrt(n)*(mean(X)-p)/sqrt(mean(X)*(1-mean(X)))
}
hist(XX)

n=5000
I=0
s2=0
for (j in c(1:n))
{
  X=runif(j,0,1)
  I[j]=4*mean(sqrt(1-X^2))
  s2[j]=16*mean(1-X^2)-I[j]^2
  }

plot(c(1:n),I+1.96*sqrt(s2)/sqrt(n),'l',col="red")
lines(c(1:n),I-1.96*sqrt(s2)/sqrt(n),col="red")
lines(c(1:n),I)


